---
product: "AG Grid"
title: "Excel Export - Excel Tables"
description: "Excel Export provides a way to export grid data as an Excel table, which would instantly enable the user to filter, sort, and analyse the data in Excel. You can instruct AG Grid to automatically create an Excel table containing the grid data when exporting to Excel."
enterprise: true
framework: javascript
version: "36.2.0"
related:
    - title: "Styles"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-styles/"
    - title: "Formulas"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-formulas/"
    - title: "Extra Content"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-extra-content/"
    - title: "Notes"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-notes/"
    - title: "Customising Content"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-customising-content/"
    - title: "Images"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-images/"
    - title: "Multiple Sheets"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-multiple-sheets/"
    - title: "Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-rows/"
    - title: "Columns"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-columns/"
    - title: "Freezing Content"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-freeze/"
    - title: "Data Types"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-data-types/"
    - title: "Hyperlinks"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-hyperlinks/"
    - title: "Master Detail"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-master-detail/"
    - title: "Page Setup"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-page-setup/"
    - title: "Data Protection"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-data-protection/"
    - title: "API Reference"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-api/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Excel Export - Excel Tables

Excel Export provides a way to export grid data as an Excel table, which would instantly enable the user to filter, sort, and analyse the data in Excel. You can instruct AG Grid to automatically create an Excel table containing the grid data when exporting to Excel.

## Exporting Excel Tables

In order to create an Excel table for the exported data, you should set the `exportAsExcelTable` property in the [ExcelExportParams](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-api/#excelexportparams) configuration object. Excel config parameters can either be set in the [defaultExcelExportParams](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grid-options/#reference-export-defaultExcelExportParams) Grid Option or passed as an argument to one of the [Excel export API methods](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-api/).

```js
const gridOptions = {
    defaultExcelExportParams: {
        exportAsExcelTable: true,
     },

    // other grid options ...
}
```

The exported Excel file will contain a sheet with a table enclosing the exported data. When you select a cell within the table, the `Table` tab in the Excel tabs toolbar will appear, which provides options to filter, sort, and analyse the data.

This is how the exported Excel file with Table looks when opened in Excel:

![Table in Excel](https://www.ag-grid.com/archive/36.2.0/_astro/excel-table-export.THI5vIxe.png)

## Exporting a Sheet as Excel Table

The following example demonstrates how to export the grid data as an Excel table.

- We set the `exportAsExcelTable` property to `true` in the `defaultExcelExportParams` Grid Option.

Proceed as follows to see the Excel table:

- You can trigger the export by clicking the `Export to Excel` button or via context menu.
- Once your file is exported, open it in Excel and select a cell within the table to see the `Table` tab.
- This example includes grouped columns, and thus only the leaf columns are included in the Excel table.
- In this example, only Athlete, and Country columns can be filtered. This is also reflected in the Excel table.

#### Excel Export - Exporting A Single Sheet as Excel Table

```ts
import {
  ClientSideRowModelModule,
  CsvExportModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  CsvExportModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    {
      headerName: "Athlete",
      children: [
        { field: "athlete", filter: true },
        { field: "age" },
        { field: "country", filter: true },
      ],
    },
    {
      headerName: "Medals",
      children: [{ field: "gold" }, { field: "silver" }, { field: "bronze" }],
    },
    { field: "total" },
  ],
  defaultColDef: {
    filter: false,
    minWidth: 100,
    flex: 1,
  },
  defaultExcelExportParams: {
    exportAsExcelTable: true,
  },
};

function onBtExport() {
  gridApi!.exportDataAsExcel();
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
  .then((response) => response.json())
  .then(function (data) {
    gridApi!.setGridOption("rowData", data);
  });

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onBtExport = onBtExport;
}
```

[Live example: Excel Export - Exporting A Single Sheet as Excel Table](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-tables/excel-export-table-single-sheet/typescript/)

## Customisation

You can customise the Excel table by providing a config object instead of a boolean value for the `exportAsExcelTable`. This config object can contain the following properties:

Properties available on the `ExcelTableConfig` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `name` | `string` |  |  |  |
| `showFilterButton` | `boolean \| 'match'` |  |  |  |
| `showRowStripes` | `boolean` |  |  |  |
| `showColumnStripes` | `boolean` |  |  |  |
| `highlightFirstColumn` | `boolean` |  |  |  |
| `highlightLastColumn` | `boolean` |  |  |  |

> **Warning**
>
> Excel tables require non-empty and unique table column names. When exporting your Grid as an Excel Table, you should ensure that the column headers are all unique and not empty.
>
> This is equally applicable when using [processHeaderCallback](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-api/#reference-ExcelExportParams-processHeaderCallback) to customise the column headers.
>
> If you have duplicate column headers, Excel will display a warning message when the exported file is opened. Excel will sometimes suggest to fix the issue automatically (by renaming the invalid table headers). However, this is not always the case, and the user may end up with a table that doesn't work as expected.

> **Note**
>
> Please note that exporting to an Excel table isn’t supported for pivot and for master/detail grids. The grid will be exported without an Excel table format.

### Row / Column Stripes and Filter Buttons

In the following example, we customise the Excel table as follows:

- `showRowStripes` - Set to `true` to show row stripes in the Excel table.
- `showColumnStripes` - Set to `true` to show column stripes in the Excel table.
- `showFilterButton` - Set to `true` to show filter buttons for all columns in the Excel table.
- `name` - Set to `Olympic Medals` to name the Excel table.

Proceed as follows to see the Excel table:

- Click the `Export to Excel` button to export the grid data as an Excel table.
- Open the exported file in Excel and select a cell within the table to see the `Table` tab.
- Notice that the stripes are only applied to the columns of the table.
- Notice that the table name is set to `Olympic_Medals`.
- Notice that the filter buttons are available for all columns in the table.

#### Excel Export - Customising Excel Table Stripes

```ts
import {
  ClientSideRowModelModule,
  CsvExportModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  CsvExportModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", filter: true },
    { field: "age" },
    { field: "country", filter: true },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ],
  defaultColDef: {
    filter: true,
    minWidth: 100,
    flex: 1,
  },
  defaultExcelExportParams: {
    exportAsExcelTable: {
      name: "Olympic Medals",
      showRowStripes: false,
      showColumnStripes: true,
      showFilterButton: true,
    },
  },
};

function onBtExport() {
  gridApi!.exportDataAsExcel();
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
  .then((response) => response.json())
  .then(function (data) {
    gridApi!.setGridOption("rowData", data);
  });

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onBtExport = onBtExport;
}
```

[Live example: Excel Export - Customising Excel Table Stripes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-tables/excel-export-table-stripes/typescript/)

### Highlighting the First and Last Columns

In the following example, we customise the Excel table as follows:

- `highlightFirstColumn` - Set to `true` to highlight the first column in the Excel table.
- `highlightLastColumn` - Set to `true` to highlight the last column in the Excel table.

Proceed as follows to see the Excel table:

- Click the `Export to Excel` button to export the grid data as an Excel table.
- Open the exported file in Excel and select a cell within the table to see the `Table` tab.
- Notice that the `Athlete` and the `Total` columns are highlighted in the table.

#### Excel Export - Highlighting the First and Last Columns

```ts
import {
  ClientSideRowModelModule,
  CsvExportModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  CsvExportModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ],
  defaultColDef: {
    filter: true,
    minWidth: 100,
    flex: 1,
  },
  defaultExcelExportParams: {
    exportAsExcelTable: {
      name: "Olympic Medals",
      highlightFirstColumn: true,
      highlightLastColumn: true,
      showRowStripes: false,
    },
  },
};

function onBtExport() {
  gridApi!.exportDataAsExcel();
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
  .then((response) => response.json())
  .then(function (data) {
    gridApi!.setGridOption("rowData", data);
  });

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onBtExport = onBtExport;
}
```

[Live example: Excel Export - Highlighting the First and Last Columns](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-tables/excel-export-table-highlight-first-last/typescript/)


---
product: "AG Grid"
title: "Excel Export - Excel Tables"
description: "Excel Export provides a way to export grid data as an Excel table, which would instantly enable the user to filter, sort, and analyse the data in Excel. You can instruct AG Grid to automatically create an Excel table containing the grid data when exporting to Excel."
enterprise: true
framework: vue
version: "36.2.0"
related:
    - title: "Styles"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-styles/"
    - title: "Formulas"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-formulas/"
    - title: "Extra Content"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-extra-content/"
    - title: "Notes"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-notes/"
    - title: "Customising Content"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-customising-content/"
    - title: "Images"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-images/"
    - title: "Multiple Sheets"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-multiple-sheets/"
    - title: "Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-rows/"
    - title: "Columns"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-columns/"
    - title: "Freezing Content"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-freeze/"
    - title: "Data Types"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-data-types/"
    - title: "Hyperlinks"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-hyperlinks/"
    - title: "Master Detail"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-master-detail/"
    - title: "Page Setup"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-page-setup/"
    - title: "Data Protection"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-data-protection/"
    - title: "API Reference"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-api/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Excel Export - Excel Tables

Excel Export provides a way to export grid data as an Excel table, which would instantly enable the user to filter, sort, and analyse the data in Excel. You can instruct AG Grid to automatically create an Excel table containing the grid data when exporting to Excel.

## Exporting Excel Tables

In order to create an Excel table for the exported data, you should set the `exportAsExcelTable` property in the [ExcelExportParams](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-api/#excelexportparams) configuration object. Excel config parameters can either be set in the [defaultExcelExportParams](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grid-options/#reference-export-defaultExcelExportParams) Grid Option or passed as an argument to one of the [Excel export API methods](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-api/).

```ts
<ag-grid-vue
    :defaultExcelExportParams="defaultExcelExportParams"
    /* other grid options ... */>
</ag-grid-vue>

this.defaultExcelExportParams = {
    exportAsExcelTable: true,
 };
```

The exported Excel file will contain a sheet with a table enclosing the exported data. When you select a cell within the table, the `Table` tab in the Excel tabs toolbar will appear, which provides options to filter, sort, and analyse the data.

This is how the exported Excel file with Table looks when opened in Excel:

![Table in Excel](https://www.ag-grid.com/archive/36.2.0/_astro/excel-table-export.THI5vIxe.png)

## Exporting a Sheet as Excel Table

The following example demonstrates how to export the grid data as an Excel table.

- We set the `exportAsExcelTable` property to `true` in the `defaultExcelExportParams` Grid Option.

Proceed as follows to see the Excel table:

- You can trigger the export by clicking the `Export to Excel` button or via context menu.
- Once your file is exported, open it in Excel and select a cell within the table to see the `Table` tab.
- This example includes grouped columns, and thus only the leaf columns are included in the Excel table.
- In this example, only Athlete, and Country columns can be filtered. This is also reflected in the Excel table.

#### Excel Export - Exporting A Single Sheet as Excel Table

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CsvExportModule,
  ExcelExportParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  CsvExportModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="container">
      <div>
        <button v-on:click="onBtExport()" style="margin-bottom: 5px; font-weight: bold">Export to Excel</button>
      </div>
      <div class="grid-wrapper">
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :columnDefs="columnDefs"
          :defaultColDef="defaultColDef"
          :defaultExcelExportParams="defaultExcelExportParams"
          :rowData="rowData"></ag-grid-vue>
        </div>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<(ColDef | ColGroupDef)[]>([
      {
        headerName: "Athlete",
        children: [
          { field: "athlete", filter: true },
          { field: "age" },
          { field: "country", filter: true },
        ],
      },
      {
        headerName: "Medals",
        children: [{ field: "gold" }, { field: "silver" }, { field: "bronze" }],
      },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      filter: false,
      minWidth: 100,
      flex: 1,
    });
    const defaultExcelExportParams = ref<ExcelExportParams>({
      exportAsExcelTable: true,
    });
    const rowData = ref<IOlympicData[]>(null);

    function onBtExport() {
      gridApi.value!.exportDataAsExcel();
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => {
        rowData.value = data;
      };

      fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      defaultExcelExportParams,
      rowData,
      onGridReady,
      onBtExport,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Excel Export - Exporting A Single Sheet as Excel Table](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-tables/excel-export-table-single-sheet/vue3/)

## Customisation

You can customise the Excel table by providing a config object instead of a boolean value for the `exportAsExcelTable`. This config object can contain the following properties:

Properties available on the `ExcelTableConfig` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `name` | `string` |  |  |  |
| `showFilterButton` | `boolean \| 'match'` |  |  |  |
| `showRowStripes` | `boolean` |  |  |  |
| `showColumnStripes` | `boolean` |  |  |  |
| `highlightFirstColumn` | `boolean` |  |  |  |
| `highlightLastColumn` | `boolean` |  |  |  |

> **Warning**
>
> Excel tables require non-empty and unique table column names. When exporting your Grid as an Excel Table, you should ensure that the column headers are all unique and not empty.
>
> This is equally applicable when using [processHeaderCallback](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-api/#reference-ExcelExportParams-processHeaderCallback) to customise the column headers.
>
> If you have duplicate column headers, Excel will display a warning message when the exported file is opened. Excel will sometimes suggest to fix the issue automatically (by renaming the invalid table headers). However, this is not always the case, and the user may end up with a table that doesn't work as expected.

> **Note**
>
> Please note that exporting to an Excel table isn’t supported for pivot and for master/detail grids. The grid will be exported without an Excel table format.

### Row / Column Stripes and Filter Buttons

In the following example, we customise the Excel table as follows:

- `showRowStripes` - Set to `true` to show row stripes in the Excel table.
- `showColumnStripes` - Set to `true` to show column stripes in the Excel table.
- `showFilterButton` - Set to `true` to show filter buttons for all columns in the Excel table.
- `name` - Set to `Olympic Medals` to name the Excel table.

Proceed as follows to see the Excel table:

- Click the `Export to Excel` button to export the grid data as an Excel table.
- Open the exported file in Excel and select a cell within the table to see the `Table` tab.
- Notice that the stripes are only applied to the columns of the table.
- Notice that the table name is set to `Olympic_Medals`.
- Notice that the filter buttons are available for all columns in the table.

#### Excel Export - Customising Excel Table Stripes

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CsvExportModule,
  ExcelExportParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  CsvExportModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="container">
      <div>
        <button v-on:click="onBtExport()" style="margin-bottom: 5px; font-weight: bold">Export to Excel</button>
      </div>
      <div class="grid-wrapper">
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :columnDefs="columnDefs"
          :defaultColDef="defaultColDef"
          :defaultExcelExportParams="defaultExcelExportParams"
          :rowData="rowData"></ag-grid-vue>
        </div>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", filter: true },
      { field: "age" },
      { field: "country", filter: true },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      filter: true,
      minWidth: 100,
      flex: 1,
    });
    const defaultExcelExportParams = ref<ExcelExportParams>({
      exportAsExcelTable: {
        name: "Olympic Medals",
        showRowStripes: false,
        showColumnStripes: true,
        showFilterButton: true,
      },
    });
    const rowData = ref<IOlympicData[]>(null);

    function onBtExport() {
      gridApi.value!.exportDataAsExcel();
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => {
        rowData.value = data;
      };

      fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      defaultExcelExportParams,
      rowData,
      onGridReady,
      onBtExport,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Excel Export - Customising Excel Table Stripes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-tables/excel-export-table-stripes/vue3/)

### Highlighting the First and Last Columns

In the following example, we customise the Excel table as follows:

- `highlightFirstColumn` - Set to `true` to highlight the first column in the Excel table.
- `highlightLastColumn` - Set to `true` to highlight the last column in the Excel table.

Proceed as follows to see the Excel table:

- Click the `Export to Excel` button to export the grid data as an Excel table.
- Open the exported file in Excel and select a cell within the table to see the `Table` tab.
- Notice that the `Athlete` and the `Total` columns are highlighted in the table.

#### Excel Export - Highlighting the First and Last Columns

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CsvExportModule,
  ExcelExportParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  CsvExportModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="container">
      <div>
        <button v-on:click="onBtExport()" style="margin-bottom: 5px; font-weight: bold">Export to Excel</button>
      </div>
      <div class="grid-wrapper">
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :columnDefs="columnDefs"
          :defaultColDef="defaultColDef"
          :defaultExcelExportParams="defaultExcelExportParams"
          :rowData="rowData"></ag-grid-vue>
        </div>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      filter: true,
      minWidth: 100,
      flex: 1,
    });
    const defaultExcelExportParams = ref<ExcelExportParams>({
      exportAsExcelTable: {
        name: "Olympic Medals",
        highlightFirstColumn: true,
        highlightLastColumn: true,
        showRowStripes: false,
      },
    });
    const rowData = ref<IOlympicData[]>(null);

    function onBtExport() {
      gridApi.value!.exportDataAsExcel();
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => {
        rowData.value = data;
      };

      fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      defaultExcelExportParams,
      rowData,
      onGridReady,
      onBtExport,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Excel Export - Highlighting the First and Last Columns](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-tables/excel-export-table-highlight-first-last/vue3/)


---
product: "AG Grid"
title: "Excel Export - Excel Tables"
description: "Excel Export provides a way to export grid data as an Excel table, which would instantly enable the user to filter, sort, and analyse the data in Excel. You can instruct AG Grid to automatically create an Excel table containing the grid data when exporting to Excel."
enterprise: true
framework: angular
version: "36.2.0"
related:
    - title: "Styles"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-styles/"
    - title: "Formulas"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-formulas/"
    - title: "Extra Content"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-extra-content/"
    - title: "Notes"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-notes/"
    - title: "Customising Content"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-customising-content/"
    - title: "Images"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-images/"
    - title: "Multiple Sheets"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-multiple-sheets/"
    - title: "Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-rows/"
    - title: "Columns"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-columns/"
    - title: "Freezing Content"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-freeze/"
    - title: "Data Types"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-data-types/"
    - title: "Hyperlinks"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-hyperlinks/"
    - title: "Master Detail"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-master-detail/"
    - title: "Page Setup"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-page-setup/"
    - title: "Data Protection"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-data-protection/"
    - title: "API Reference"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-api/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Excel Export - Excel Tables

Excel Export provides a way to export grid data as an Excel table, which would instantly enable the user to filter, sort, and analyse the data in Excel. You can instruct AG Grid to automatically create an Excel table containing the grid data when exporting to Excel.

## Exporting Excel Tables

In order to create an Excel table for the exported data, you should set the `exportAsExcelTable` property in the [ExcelExportParams](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-api/#excelexportparams) configuration object. Excel config parameters can either be set in the [defaultExcelExportParams](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grid-options/#reference-export-defaultExcelExportParams) Grid Option or passed as an argument to one of the [Excel export API methods](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-api/).

```ts
<ag-grid-angular
    [defaultExcelExportParams]="defaultExcelExportParams"
    /* other grid options ... */ />

this.defaultExcelExportParams = {
    exportAsExcelTable: true,
 };
```

The exported Excel file will contain a sheet with a table enclosing the exported data. When you select a cell within the table, the `Table` tab in the Excel tabs toolbar will appear, which provides options to filter, sort, and analyse the data.

This is how the exported Excel file with Table looks when opened in Excel:

![Table in Excel](https://www.ag-grid.com/archive/36.2.0/_astro/excel-table-export.THI5vIxe.png)

## Exporting a Sheet as Excel Table

The following example demonstrates how to export the grid data as an Excel table.

- We set the `exportAsExcelTable` property to `true` in the `defaultExcelExportParams` Grid Option.

Proceed as follows to see the Excel table:

- You can trigger the export by clicking the `Export to Excel` button or via context menu.
- Once your file is exported, open it in Excel and select a cell within the table to see the `Table` tab.
- This example includes grouped columns, and thus only the leaf columns are included in the Excel table.
- In this example, only Athlete, and Country columns can be filtered. This is also reflected in the Excel table.

#### Excel Export - Exporting A Single Sheet as Excel Table

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CsvExportModule,
  ExcelExportParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  CsvExportModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="container">
    <div>
      <button
        (click)="onBtExport()"
        style="margin-bottom: 5px; font-weight: bold"
      >
        Export to Excel
      </button>
    </div>
    <div class="grid-wrapper">
      <ag-grid-angular
        style="width: 100%; height: 100%;"
        [columnDefs]="columnDefs"
        [defaultColDef]="defaultColDef"
        [defaultExcelExportParams]="defaultExcelExportParams"
        [rowData]="rowData"
        (gridReady)="onGridReady($event)"
      />
    </div>
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IOlympicData>;

  columnDefs: (ColDef | ColGroupDef)[] = [
    {
      headerName: "Athlete",
      children: [
        { field: "athlete", filter: true },
        { field: "age" },
        { field: "country", filter: true },
      ],
    },
    {
      headerName: "Medals",
      children: [{ field: "gold" }, { field: "silver" }, { field: "bronze" }],
    },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    filter: false,
    minWidth: 100,
    flex: 1,
  };
  defaultExcelExportParams: ExcelExportParams = {
    exportAsExcelTable: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onBtExport() {
    this.gridApi.exportDataAsExcel();
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.gridApi = params.api;

    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
      .subscribe((data) => {
        this.rowData = data;
      });
  }
}
```

[Live example: Excel Export - Exporting A Single Sheet as Excel Table](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-tables/excel-export-table-single-sheet/angular/)

## Customisation

You can customise the Excel table by providing a config object instead of a boolean value for the `exportAsExcelTable`. This config object can contain the following properties:

Properties available on the `ExcelTableConfig` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `name` | `string` |  |  |  |
| `showFilterButton` | `boolean \| 'match'` |  |  |  |
| `showRowStripes` | `boolean` |  |  |  |
| `showColumnStripes` | `boolean` |  |  |  |
| `highlightFirstColumn` | `boolean` |  |  |  |
| `highlightLastColumn` | `boolean` |  |  |  |

> **Warning**
>
> Excel tables require non-empty and unique table column names. When exporting your Grid as an Excel Table, you should ensure that the column headers are all unique and not empty.
>
> This is equally applicable when using [processHeaderCallback](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-api/#reference-ExcelExportParams-processHeaderCallback) to customise the column headers.
>
> If you have duplicate column headers, Excel will display a warning message when the exported file is opened. Excel will sometimes suggest to fix the issue automatically (by renaming the invalid table headers). However, this is not always the case, and the user may end up with a table that doesn't work as expected.

> **Note**
>
> Please note that exporting to an Excel table isn’t supported for pivot and for master/detail grids. The grid will be exported without an Excel table format.

### Row / Column Stripes and Filter Buttons

In the following example, we customise the Excel table as follows:

- `showRowStripes` - Set to `true` to show row stripes in the Excel table.
- `showColumnStripes` - Set to `true` to show column stripes in the Excel table.
- `showFilterButton` - Set to `true` to show filter buttons for all columns in the Excel table.
- `name` - Set to `Olympic Medals` to name the Excel table.

Proceed as follows to see the Excel table:

- Click the `Export to Excel` button to export the grid data as an Excel table.
- Open the exported file in Excel and select a cell within the table to see the `Table` tab.
- Notice that the stripes are only applied to the columns of the table.
- Notice that the table name is set to `Olympic_Medals`.
- Notice that the filter buttons are available for all columns in the table.

#### Excel Export - Customising Excel Table Stripes

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CsvExportModule,
  ExcelExportParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  CsvExportModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="container">
    <div>
      <button
        (click)="onBtExport()"
        style="margin-bottom: 5px; font-weight: bold"
      >
        Export to Excel
      </button>
    </div>
    <div class="grid-wrapper">
      <ag-grid-angular
        style="width: 100%; height: 100%;"
        [columnDefs]="columnDefs"
        [defaultColDef]="defaultColDef"
        [defaultExcelExportParams]="defaultExcelExportParams"
        [rowData]="rowData"
        (gridReady)="onGridReady($event)"
      />
    </div>
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IOlympicData>;

  columnDefs: ColDef[] = [
    { field: "athlete", filter: true },
    { field: "age" },
    { field: "country", filter: true },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    filter: true,
    minWidth: 100,
    flex: 1,
  };
  defaultExcelExportParams: ExcelExportParams = {
    exportAsExcelTable: {
      name: "Olympic Medals",
      showRowStripes: false,
      showColumnStripes: true,
      showFilterButton: true,
    },
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onBtExport() {
    this.gridApi.exportDataAsExcel();
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.gridApi = params.api;

    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
      .subscribe((data) => {
        this.rowData = data;
      });
  }
}
```

[Live example: Excel Export - Customising Excel Table Stripes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-tables/excel-export-table-stripes/angular/)

### Highlighting the First and Last Columns

In the following example, we customise the Excel table as follows:

- `highlightFirstColumn` - Set to `true` to highlight the first column in the Excel table.
- `highlightLastColumn` - Set to `true` to highlight the last column in the Excel table.

Proceed as follows to see the Excel table:

- Click the `Export to Excel` button to export the grid data as an Excel table.
- Open the exported file in Excel and select a cell within the table to see the `Table` tab.
- Notice that the `Athlete` and the `Total` columns are highlighted in the table.

#### Excel Export - Highlighting the First and Last Columns

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CsvExportModule,
  ExcelExportParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  CsvExportModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="container">
    <div>
      <button
        (click)="onBtExport()"
        style="margin-bottom: 5px; font-weight: bold"
      >
        Export to Excel
      </button>
    </div>
    <div class="grid-wrapper">
      <ag-grid-angular
        style="width: 100%; height: 100%;"
        [columnDefs]="columnDefs"
        [defaultColDef]="defaultColDef"
        [defaultExcelExportParams]="defaultExcelExportParams"
        [rowData]="rowData"
        (gridReady)="onGridReady($event)"
      />
    </div>
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IOlympicData>;

  columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    filter: true,
    minWidth: 100,
    flex: 1,
  };
  defaultExcelExportParams: ExcelExportParams = {
    exportAsExcelTable: {
      name: "Olympic Medals",
      highlightFirstColumn: true,
      highlightLastColumn: true,
      showRowStripes: false,
    },
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onBtExport() {
    this.gridApi.exportDataAsExcel();
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.gridApi = params.api;

    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
      .subscribe((data) => {
        this.rowData = data;
      });
  }
}
```

[Live example: Excel Export - Highlighting the First and Last Columns](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-tables/excel-export-table-highlight-first-last/angular/)


---
product: "AG Grid"
title: "Excel Export - Excel Tables"
description: "Excel Export provides a way to export grid data as an Excel table, which would instantly enable the user to filter, sort, and analyse the data in Excel. You can instruct AG Grid to automatically create an Excel table containing the grid data when exporting to Excel."
enterprise: true
framework: react
version: "36.2.0"
related:
    - title: "Styles"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-styles/"
    - title: "Formulas"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-formulas/"
    - title: "Extra Content"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-extra-content/"
    - title: "Notes"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-notes/"
    - title: "Customising Content"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-customising-content/"
    - title: "Images"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-images/"
    - title: "Multiple Sheets"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-multiple-sheets/"
    - title: "Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-rows/"
    - title: "Columns"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-columns/"
    - title: "Freezing Content"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-freeze/"
    - title: "Data Types"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-data-types/"
    - title: "Hyperlinks"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-hyperlinks/"
    - title: "Master Detail"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-master-detail/"
    - title: "Page Setup"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-page-setup/"
    - title: "Data Protection"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-data-protection/"
    - title: "API Reference"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-api/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Excel Export - Excel Tables

Excel Export provides a way to export grid data as an Excel table, which would instantly enable the user to filter, sort, and analyse the data in Excel. You can instruct AG Grid to automatically create an Excel table containing the grid data when exporting to Excel.

## Exporting Excel Tables

In order to create an Excel table for the exported data, you should set the `exportAsExcelTable` property in the [ExcelExportParams](https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-api/#excelexportparams) configuration object. Excel config parameters can either be set in the [defaultExcelExportParams](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grid-options/#reference-export-defaultExcelExportParams) Grid Option or passed as an argument to one of the [Excel export API methods](https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-api/).

```jsx
const defaultExcelExportParams = useMemo(() => { 
	return {
        exportAsExcelTable: true,
     };
}, []);

<AgGridReact defaultExcelExportParams={defaultExcelExportParams} />
```

The exported Excel file will contain a sheet with a table enclosing the exported data. When you select a cell within the table, the `Table` tab in the Excel tabs toolbar will appear, which provides options to filter, sort, and analyse the data.

This is how the exported Excel file with Table looks when opened in Excel:

![Table in Excel](https://www.ag-grid.com/archive/36.2.0/_astro/excel-table-export.THI5vIxe.png)

## Exporting a Sheet as Excel Table

The following example demonstrates how to export the grid data as an Excel table.

- We set the `exportAsExcelTable` property to `true` in the `defaultExcelExportParams` Grid Option.

Proceed as follows to see the Excel table:

- You can trigger the export by clicking the `Export to Excel` button or via context menu.
- Once your file is exported, open it in Excel and select a cell within the table to see the `Table` tab.
- This example includes grouped columns, and thus only the leaf columns are included in the Excel table.
- In this example, only Athlete, and Country columns can be filtered. This is also reflected in the Excel table.

#### Excel Export - Exporting A Single Sheet as Excel Table

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CsvExportModule,
  ExcelExportParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  CsvExportModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
];

const GridExample = () => {
  const gridRef = useRef<AgGridReact<IOlympicData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<(ColDef | ColGroupDef)[]>([
    {
      headerName: "Athlete",
      children: [
        { field: "athlete", filter: true },
        { field: "age" },
        { field: "country", filter: true },
      ],
    },
    {
      headerName: "Medals",
      children: [{ field: "gold" }, { field: "silver" }, { field: "bronze" }],
    },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      filter: false,
      minWidth: 100,
      flex: 1,
    };
  }, []);
  const defaultExcelExportParams = useMemo<ExcelExportParams>(() => {
    return {
      exportAsExcelTable: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/small-olympic-winners.json",
  );

  const onBtExport = useCallback(() => {
    gridRef.current!.api.exportDataAsExcel();
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="container">
          <div>
            <button
              onClick={onBtExport}
              style={{ marginBottom: "5px", fontWeight: "bold" }}
            >
              Export to Excel
            </button>
          </div>
          <div className="grid-wrapper">
            <div style={gridStyle}>
              <AgGridReact<IOlympicData>
                ref={gridRef}
                rowData={data}
                loading={loading}
                columnDefs={columnDefs}
                defaultColDef={defaultColDef}
                defaultExcelExportParams={defaultExcelExportParams}
              />
            </div>
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Excel Export - Exporting A Single Sheet as Excel Table](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-tables/excel-export-table-single-sheet/reactFunctionalTs/)

## Customisation

You can customise the Excel table by providing a config object instead of a boolean value for the `exportAsExcelTable`. This config object can contain the following properties:

Properties available on the `ExcelTableConfig` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `name` | `string` |  |  |  |
| `showFilterButton` | `boolean \| 'match'` |  |  |  |
| `showRowStripes` | `boolean` |  |  |  |
| `showColumnStripes` | `boolean` |  |  |  |
| `highlightFirstColumn` | `boolean` |  |  |  |
| `highlightLastColumn` | `boolean` |  |  |  |

> **Warning**
>
> Excel tables require non-empty and unique table column names. When exporting your Grid as an Excel Table, you should ensure that the column headers are all unique and not empty.
>
> This is equally applicable when using [processHeaderCallback](https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-api/#reference-ExcelExportParams-processHeaderCallback) to customise the column headers.
>
> If you have duplicate column headers, Excel will display a warning message when the exported file is opened. Excel will sometimes suggest to fix the issue automatically (by renaming the invalid table headers). However, this is not always the case, and the user may end up with a table that doesn't work as expected.

> **Note**
>
> Please note that exporting to an Excel table isn’t supported for pivot and for master/detail grids. The grid will be exported without an Excel table format.

### Row / Column Stripes and Filter Buttons

In the following example, we customise the Excel table as follows:

- `showRowStripes` - Set to `true` to show row stripes in the Excel table.
- `showColumnStripes` - Set to `true` to show column stripes in the Excel table.
- `showFilterButton` - Set to `true` to show filter buttons for all columns in the Excel table.
- `name` - Set to `Olympic Medals` to name the Excel table.

Proceed as follows to see the Excel table:

- Click the `Export to Excel` button to export the grid data as an Excel table.
- Open the exported file in Excel and select a cell within the table to see the `Table` tab.
- Notice that the stripes are only applied to the columns of the table.
- Notice that the table name is set to `Olympic_Medals`.
- Notice that the filter buttons are available for all columns in the table.

#### Excel Export - Customising Excel Table Stripes

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CsvExportModule,
  ExcelExportParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  CsvExportModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
];

const GridExample = () => {
  const gridRef = useRef<AgGridReact<IOlympicData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", filter: true },
    { field: "age" },
    { field: "country", filter: true },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      filter: true,
      minWidth: 100,
      flex: 1,
    };
  }, []);
  const defaultExcelExportParams = useMemo<ExcelExportParams>(() => {
    return {
      exportAsExcelTable: {
        name: "Olympic Medals",
        showRowStripes: false,
        showColumnStripes: true,
        showFilterButton: true,
      },
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/small-olympic-winners.json",
  );

  const onBtExport = useCallback(() => {
    gridRef.current!.api.exportDataAsExcel();
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="container">
          <div>
            <button
              onClick={onBtExport}
              style={{ marginBottom: "5px", fontWeight: "bold" }}
            >
              Export to Excel
            </button>
          </div>
          <div className="grid-wrapper">
            <div style={gridStyle}>
              <AgGridReact<IOlympicData>
                ref={gridRef}
                rowData={data}
                loading={loading}
                columnDefs={columnDefs}
                defaultColDef={defaultColDef}
                defaultExcelExportParams={defaultExcelExportParams}
              />
            </div>
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Excel Export - Customising Excel Table Stripes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-tables/excel-export-table-stripes/reactFunctionalTs/)

### Highlighting the First and Last Columns

In the following example, we customise the Excel table as follows:

- `highlightFirstColumn` - Set to `true` to highlight the first column in the Excel table.
- `highlightLastColumn` - Set to `true` to highlight the last column in the Excel table.

Proceed as follows to see the Excel table:

- Click the `Export to Excel` button to export the grid data as an Excel table.
- Open the exported file in Excel and select a cell within the table to see the `Table` tab.
- Notice that the `Athlete` and the `Total` columns are highlighted in the table.

#### Excel Export - Highlighting the First and Last Columns

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CsvExportModule,
  ExcelExportParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  CsvExportModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
];

const GridExample = () => {
  const gridRef = useRef<AgGridReact<IOlympicData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      filter: true,
      minWidth: 100,
      flex: 1,
    };
  }, []);
  const defaultExcelExportParams = useMemo<ExcelExportParams>(() => {
    return {
      exportAsExcelTable: {
        name: "Olympic Medals",
        highlightFirstColumn: true,
        highlightLastColumn: true,
        showRowStripes: false,
      },
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/small-olympic-winners.json",
  );

  const onBtExport = useCallback(() => {
    gridRef.current!.api.exportDataAsExcel();
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="container">
          <div>
            <button
              onClick={onBtExport}
              style={{ marginBottom: "5px", fontWeight: "bold" }}
            >
              Export to Excel
            </button>
          </div>
          <div className="grid-wrapper">
            <div style={gridStyle}>
              <AgGridReact<IOlympicData>
                ref={gridRef}
                rowData={data}
                loading={loading}
                columnDefs={columnDefs}
                defaultColDef={defaultColDef}
                defaultExcelExportParams={defaultExcelExportParams}
              />
            </div>
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Excel Export - Highlighting the First and Last Columns](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-tables/excel-export-table-highlight-first-last/reactFunctionalTs/)
